<template>
  <v-card elevation="0" outlined class="mt-5 mb-5">
    <v-container fluid>
      <v-row class="pl-5 pr-5" justify="space-between">
        <v-card-title>
          <small>Adresat</small>
          <f-action-btn
            icon="mdi-plus"
            @click="createClientAddressModal = true"
          />
        </v-card-title>
        <v-spacer />
        <v-col cols="3">
          <search-input v-model="search" />
        </v-col>
      </v-row>
    </v-container>
    <v-data-table
      dense
      :headers="headers"
      :items="addresses"
      outlined
      :footer-props="{
        'items-per-page-options': [5, 10, 15],
      }"
    >
      <template v-slot:item="row">
        <tr>
          <td>{{ row.index + 1 }}</td>
          <td>{{ row.item.address }}</td>
          <td>{{ row.item.zip_code }}</td>
          <td>{{ row.item.city }}</td>
          <td>{{ row.item.country }}</td>
          <td>
            <f-edit-btn @click="openClientAddressModal(row.item)" />
            <f-delete-btn @click="deleteAddress(row.index)" />
          </td>
        </tr>
      </template>
    </v-data-table>
    <create-client-address v-model="createClientAddressModal" />
    <edit-client-address
      v-model="editClientAddressModal"
      :address="selectedAddress"
    />
  </v-card>
</template>
<script lang="ts">
import { Component, Prop, Mixins } from 'vue-property-decorator'
import Table from '../../../plugins/table'
import eventBus from '../../../plugins/event-bus'
import FActionBtn from '../../../components/buttons/FActionBtn.vue'
import FEditBtn from '../../../components/buttons/FEditBtn.vue'
import FDeleteBtn from '../../../components/buttons/FDeleteBtn.vue'
import SearchInput from '../../../components/inputs/SearchInput.vue'
import CreateClientAddress from './Address/CreateClientAddress.vue'
import EditClientAddress from './Address/EditClientAddress.vue'

const datatableHeader = [
  { text: 'Id', value: 'id', sortable: false, class: 'grey lighten-4' },
  {
    text: 'Adresa',
    value: 'address',
    sortable: false,
    class: 'grey lighten-4',
  },
  {
    text: 'Kodi Postar',
    value: 'zip_code',
    sortable: false,
    class: 'grey lighten-4',
  },
  { text: 'Qyteti', value: 'city', sortable: false, class: 'grey lighten-4' },
  {
    text: 'Shteti',
    value: 'country',
    sortable: false,
    class: 'grey lighten-4',
  },
  {
    text: 'Veprime',
    value: 'actions',
    sortable: false,
    class: 'grey lighten-4',
  },
]
@Component({
  components: {
    FActionBtn,
    SearchInput,
    FEditBtn,
    FDeleteBtn,
    CreateClientAddress,
    EditClientAddress,
  },
})
export default class ClientAddress extends Mixins(Table) {
  @Prop({ type: Number, default: 1 }) clientId
  @Prop({ type: Array }) clientAddress
  @Prop({ required: true, default: () => [] }) value

  search = ''
  address = null
  zip_code = null
  city = null
  country = null
  incrementId = 1
  selectedAddress = null
  headers = datatableHeader
  createClientAddressModal = false
  editClientAddressModal = false

  get addresses() {
    return this.value
  }
  set addresses(newValue) {
    this.$emit('input', newValue)
  }
  mounted() {
    this.addAddress()
    this.editAddress()
    this.clearInputs()

    if (this.clientAddress) {
      this.addresses = this.clientAddress
    }
  }
  clearInputs() {
    eventBus.$on('clear-inputs', () => {
      this.addresses = []
    })
  }
  deleteAddress(index) {
    this.addresses.splice(index, 1)
    eventBus.$emit('delete-address', index)
  }
  addAddress() {
    eventBus.$on('add-address', newValue => {
      this.address = newValue.address
      this.zip_code = newValue.zip_code
      this.city = newValue.city
      this.country = newValue.country

      this.addresses.push({
        id: this.incrementId++,
        address: this.address,
        zip_code: this.zip_code,
        city: this.city,
        country: this.country,
      })
    })
  }
  editAddress() {
    eventBus.$on('edit-address', newValue => {
      this.addresses
        .filter(address => address.id === newValue.id)
        .map(el => {
          el.id = newValue.id
          el.address = newValue.address
          el.zip_code = newValue.zip_code
          el.city = newValue.city
          el.country = newValue.country
        })
    })
  }
  openClientAddressModal(address) {
    this.editClientAddressModal = true
    this.selectedAddress = address
  }
}
</script>

<style scoped>
.action-btn {
  margin: 7px 7px;
}
</style>
